package dev.thebread

import java.sql.PreparedStatement
import java.time.LocalDate


abstract class Model {
    enum class PreparedStatementCase {
        GET_USERS, GET_LIST_FOR_USER, GET_LISTS, GET_STAGES_FOR_LIST,
        ADD_LIST, ADD_USER, ADD_LIST_FOR_USER, ADD_STAGE_FOR_LIST, ADD_TASK_TO_LIST,
        MOVE_TASK_TO_STAGE,
        REMOVE_TASK, REMOVE_USER, REMOVE_LIST_FOR_USER,
        REG_LOCAL_FOR_USER, REG_DISCORD_FOR_USER, REG_GOOGLE_FOR_USER,
        CLEANUP,
    }

    companion object Common {
        public var stmts: Map<PreparedStatementCase, PreparedStatement>? = null
    }

    abstract var id: Int?

    fun id(): Int? {
        if(id == null) {
            this.id = create().id
        }
        return id
    }
    fun setStatements(stmts: Map<PreparedStatementCase, PreparedStatement>) {
        Common.stmts = stmts
    }

    abstract fun get(id: Int): Model?
    abstract fun getAll(): Set<Model>
    abstract fun create(): Model

}

class Models {
    class User {
        val name: String? = null
        val discord: Int? = null
        val google: Int? = null
    }

    class List {
        val id: Int? = null
        val name: String? = null
        val description: String? = null
    }

    class Task {
        class Stage {
            val id: Int? = null
            val name: String? = null
            val description: String? = null
            val list: List? = null
        }

        val id: Int? = null
        val name: String? = null
        val description: String? = null
        val stage: Stage? = null
        val due: LocalDate? = null
        val dueStage: Stage? = null
    }
}